Ruby master - Misc #15605

json library needs more frequent releases
02/15/2019 01:40 AM - headius (Charles Nutter)

Status: Open
Priority: Normal
Assignee:

Description

There has not been a release of the json gem since April 2017.

Unfortunately there's a long backlog of bugs and pull requests that have been sitting there, including some that prevent users from

upgrading JRuby.

I think most of us who have been working on Ruby for any length of time knows that it has been difficult to get json changes

released, and it's now starting to really hold back other development.

| propose that we start looking for an alternative maintainer of the library, find a way to get them push rights, and end this bottleneck.

FWIW only flori and | currently have push rights for the gem, but | do not have push rights for the repository.

History

#1 - 02/15/2019 01:43 AM - headius (Charles Nutter)

There are five open pull requests relating to JRuby: https://github.com/flori/json/pulls ?utf8=%E2%9C%93&Qg=is%3Apr+is%3Aopen-+jruby

There are 26 open pull requests in total.

#2 - 02/15/2019 01:45 AM - headius (Charles Nutter)

| want to be clear that we are very thankful for the work that flori has put in over the years. | understand people don't always have time to work on

OSS, or move on to other things, but this is a critical, core Ruby standard library...we need to be able to spin versions much more frequently.

#3 - 02/15/2019 03:06 AM - headius (Charles Nutter)

- Subject changed from json library needs a more responsive maintainer to json library needs more frequent releases

#4 - 02/15/2019 11:35 AM - shevegen (Robert A. Heiler)

I think this can be "abstracted" out in the sense of a general mechanism in place when
it comes to gems that are part of the official ruby distribution, and maintainers that
become inactive or at the least less active.

In particular when it comes to pull requests, aka code that already exists but is
not merged in, | agree completely with Charles. (Let's assume here that these
changes all work fine, without breaking stuff, just to simplify the argument.)

Perhaps a better general solution may be to allow the ruby main team to decide
who is co-owner of gems IF these gems are part of the official ruby distribution.
That way e. g. Charles or other folks (decided by core devs) could at the least
add in the patches. Alternatively things could always be forked anyway and then
merged in.

Since Charles mention it ("find a way to get them push rights"), what would be a
simple way to get others into the position to have push rights? Could that work

on rubygems/gems + rubygems.org alone or does this have to include github-hosted
code? For the latter it may be feasible to have it all under the main ruby

site on github. (Ideally of course, everything could be managed in-ruby, without
having to depend on any external source, but | also understand that github made
some feature/access simpler.)

IMO this may be something for the next developer meeting - this can happen to
other gems too, so it seems more general to me.

Edit: May fit better into "Misc" than "Bugs" per se, but it's not really that
important in which category it is.

#5 - 02/17/2019 01:08 AM - naruse (Yui NARUSE)
https://github.com/flori/json/pulls?utf8=%E2%9C%93&q=is%3Apr+is%3Aopen+jruby

You may know hsbt and | get write access to repo recently.

So for those JRuby issues, you can ask us to merge after you review it.

And also you can push gem, we can handle fix an issue and push a gem if there's a emergency.
Anyway we also worried about json.gem..

#6 - 02/17/2019 11:18 AM - Eregon (Benoit Daloze)

Would it make sense to move the repository under the ruby organization, since it is a default gem maintained by ruby-core now?

#7 - 02/21/2019 03:28 PM - headius (Charles Nutter)

Perhaps a better general solution may be to allow the ruby main team to decide who is co-owner of gems IF these gems are part of the official
ruby distribution.

This seems like a good rule of thumb. | know we've had trouble finding maintainers for some libraries, but anything that lives as an external gem
should have at least two maintainers always in case one gets pulled away. The json gem has for too long had only the one maintainer, other than
partial support from JRuby team for our version of the extension.

You may know hsbt and | get write access to repo recently.

That's great! We'll ping you from the relevant PRs we need merged and we can talk about a release.

I'm not sure whether | can (or should) add naruse or hsbt as a gem pusher...but | think we need someone (other than flori) from the C side to also be
able to push the gem when there's fixes.

Would it make sense to move the repository under the ruby organization, since it is a default gem maintained by ruby-core now?

I think it would be worthwhile to do this for every gem that's included as part of stdlib. The racc library has similar issues, not because of unresponsive
maintainers but because nobody really wants to own it anymore. I've been trying to get some fixes in there and released too (working with tenderlove
on and off this month to do that).

#8 - 03/13/2019 01:21 PM - headius (Charles Nutter)

FWIW we did just get a json 2.2.0 release. The base problem stands, however.

#9 - 06/12/2019 11:43 PM - jeremyevans0 (Jeremy Evans)
- Backport deleted (2.4: UNKNOWN, 2.5: UNKNOWN, 2.6: UNKNOWN)
- ruby -v deleted (all)

- Tracker changed from Bug to Misc
